# ucsdet.h File Reference

C API: Charset Detection API. More...

`#include "unicode/utypes.h"`
`#include "unicode/uenum.h"`

Go to the source code of this file.

## Typedefs
typedef struct UCharsetDetector | UCharsetDetector
| Structure representing a charset detector.
typedef struct UCharsetMatch | UCharsetMatch
| Opaque structure representing a match that was identified from a charset detection operation.
## Functions
UCharsetDetector * | ucsdet_open (UErrorCode *status)
| Open a charset detector.
void | ucsdet_close (UCharsetDetector *ucsd)
| Close a charset detector.
void | ucsdet_setText (UCharsetDetector *ucsd, const char *textIn, int32_t len, UErrorCode *status)
| Set the input byte data whose charset is to detected.
void | ucsdet_setDeclaredEncoding (UCharsetDetector *ucsd, const char *encoding, int32_t length, UErrorCode *status)
| Set the declared encoding for charset detection.
const UCharsetMatch * | ucsdet_detect (UCharsetDetector *ucsd, UErrorCode *status)
| Return the charset that best matches the supplied input data.
const UCharsetMatch ** | ucsdet_detectAll (UCharsetDetector *ucsd, int32_t *matchesFound, UErrorCode *status)
| Find all charset matches that appear to be consistent with the input, returning an array of results.
const char * | ucsdet_getName (const UCharsetMatch *ucsm, UErrorCode *status)
| Get the name of the charset represented by a UCharsetMatch.
int32_t | ucsdet_getConfidence (const UCharsetMatch *ucsm, UErrorCode *status)
| Get a confidence number for the quality of the match of the byte data with the charset.
const char * | ucsdet_getLanguage (const UCharsetMatch *ucsm, UErrorCode *status)
| Get the RFC 3066 code for the language of the input data.
int32_t | ucsdet_getUChars (const UCharsetMatch *ucsm, UChar *buf, int32_t cap, UErrorCode *status)
| Get the entire input text as a UChar string, placing it into a caller-supplied buffer.
UEnumeration * | ucsdet_getAllDetectableCharsets (const UCharsetDetector *ucsd, UErrorCode *status)
| Get an iterator over the set of all detectable charsets - over the charsets that are known to the charset detection service.
UBool | ucsdet_isInputFilterEnabled (const UCharsetDetector *ucsd)
| Test whether input filtering is enabled for this charset detector.
UBool | ucsdet_enableInputFilter (UCharsetDetector *ucsd, UBool filter)
| Enable filtering of input text.

## Detailed Description

C API: Charset Detection API.

This API provides a facility for detecting the charset or encoding of character data in an unknown text format. The input data can be from an array of bytes.

Character set detection is at best an imprecise operation. The detection process will attempt to identify the charset that best matches the characteristics of the byte data, but the process is partly statistical in nature, and the results can not be guaranteed to always be correct.

For best accuracy in charset detection, the input data should be primarily in a single language, and a minimum of a few hundred bytes worth of plain text in the language are needed. The detection process will attempt to ignore html or xml style markup that could otherwise obscure the content.

Definition in file ucsdet.h.

## Typedef Documentation

typedef struct UCharsetDetector UCharsetDetector

Structure representing a charset detector.

Stable:
  ICU 3.6

Definition at line 52 of file ucsdet.h.

typedef struct UCharsetMatch UCharsetMatch

Opaque structure representing a match that was identified from a charset detection operation.

Stable:
  ICU 3.6

Definition at line 60 of file ucsdet.h.

## Function Documentation

void ucsdet_close | ( | UCharsetDetector * | ucsd | ) |

Close a charset detector.

All storage and any other resources owned by this charset detector will be released. Failure to close a charset detector when finished with it can result in memory leaks in the application.

Parameters:

  | ucsd | The charset detector to be closed.

Stable:
  ICU 3.6

const UCharsetMatch* ucsdet_detect | ( | UCharsetDetector * | ucsd,
|  | UErrorCode * | status |
| ) |  |  |

Return the charset that best matches the supplied input data.

Note though, that because the detection only looks at the start of the input data, there is a possibility that the returned charset will fail to handle the full set of input data.

The returned UCharsetMatch object is owned by the UCharsetDetector. It will remain valid until the detector input is reset, or until the detector is closed.

The function will fail if

- no charset appears to match the data.
- no input text has been provided

Parameters:

  | ucsd | the charset detector to be used.
  | status | any error conditions are reported back in this variable.

Returns:
  a UCharsetMatch representing the best matching charset, or NULL if no charset matches the byte data.

Stable:
  ICU 3.6

const UCharsetMatch** ucsdet_detectAll | ( | UCharsetDetector * | ucsd,
|  | int32_t * | matchesFound,
|  | UErrorCode * | status |
| ) |  |  |

Find all charset matches that appear to be consistent with the input, returning an array of results.

The results are ordered with the best quality match first.

Because the detection only looks at a limited amount of the input byte data, some of the returned charsets may fail to handle the all of input data.

The returned UCharsetMatch objects are owned by the UCharsetDetector. They will remain valid until the detector is closed or modified

Return an error if

- no charsets appear to match the input data.
- no input text has been provided

Parameters:

  | ucsd | the charset detector to be used.
  | matchesFound | pointer to a variable that will be set to the number of charsets identified that are consistent with the input data. Output only.
  | status | any error conditions are reported back in this variable.

Returns:
  A pointer to an array of pointers to UCharSetMatch objects. This array, and the UCharSetMatch instances to which it refers, are owned by the UCharsetDetector, and will remain valid until the detector is closed or modified.

Stable:
  ICU 3.6

UBool ucsdet_enableInputFilter | ( | UCharsetDetector * | ucsd,
|  | UBool | filter |
| ) |  |  |

Enable filtering of input text.

If filtering is enabled, text within angle brackets ("<" and ">") will be removed before detection, which will remove most HTML or xml markup.

Parameters:

  | ucsd | the charset detector to be modified.
  | filter | `true` to enable input text filtering.

Returns:
  The previous setting.

Stable:
  ICU 3.6

UEnumeration* ucsdet_getAllDetectableCharsets | ( | const UCharsetDetector * | ucsd,
|  | UErrorCode * | status |
| ) |  |  |

Get an iterator over the set of all detectable charsets - over the charsets that are known to the charset detection service.

The returned UEnumeration provides access to the names of the charsets.

The state of the Charset detector that is passed in does not affect the result of this function, but requiring a valid, open charset detector as a parameter insures that the charset detection service has been safely initialized and that the required detection data is available.

Parameters:

  | ucsd | a Charset detector.
  | status | Any error conditions are reported back in this variable.

Returns:
  an iterator providing access to the detectable charset names.

Stable:
  ICU 3.6

int32_t ucsdet_getConfidence | ( | const UCharsetMatch * | ucsm,
|  | UErrorCode * | status |
| ) |  |  |

Get a confidence number for the quality of the match of the byte data with the charset.

Confidence numbers range from zero to 100, with 100 representing complete confidence and zero representing no confidence.

The confidence values are somewhat arbitrary. They define an an ordering within the results for any single detection operation but are not generally comparable between the results for different input.

A confidence value of ten does have a general meaning - it is used for charsets that can represent the input data, but for which there is no other indication that suggests that the charset is the correct one. Pure 7 bit ASCII data, for example, is compatible with a great many charsets, most of which will appear as possible matches with a confidence of 10.

Parameters:

  | ucsm | The charset match object.
  | status | Any error conditions are reported back in this variable.

Returns:
  A confidence number for the charset match.

Stable:
  ICU 3.6

const char* ucsdet_getLanguage | ( | const UCharsetMatch * | ucsm,
|  | UErrorCode * | status |
| ) |  |  |

Get the RFC 3066 code for the language of the input data.

The Charset Detection service is intended primarily for detecting charsets, not language. For some, but not all, charsets, a language is identified as a byproduct of the detection process, and that is what is returned by this function.

CAUTION: 1. Language information is not available for input data encoded in all charsets. In particular, no language is identified for UTF-8 input data.

2. Closely related languages may sometimes be confused.

If more accurate language detection is required, a linguistic analysis package should be used.

The storage for the returned name string is owned by the UCharsetMatch, and will remain valid while the UCharsetMatch is valid.

Parameters:

  | ucsm | The charset match object.
  | status | Any error conditions are reported back in this variable.

Returns:
  The RFC 3066 code for the language of the input data, or an empty string if the language could not be determined.

Stable:
  ICU 3.6

const char* ucsdet_getName | ( | const UCharsetMatch * | ucsm,
|  | UErrorCode * | status |
| ) |  |  |

Get the name of the charset represented by a UCharsetMatch.

The storage for the returned name string is owned by the UCharsetMatch, and will remain valid while the UCharsetMatch is valid.

The name returned is suitable for use with the ICU conversion APIs.

Parameters:

  | ucsm | The charset match object.
  | status | Any error conditions are reported back in this variable.

Returns:
  The name of the matching charset.

Stable:
  ICU 3.6

int32_t ucsdet_getUChars | ( | const UCharsetMatch * | ucsm,
|  | UChar * | buf,
|  | int32_t | cap,
|  | UErrorCode * | status |
| ) |  |  |

Get the entire input text as a UChar string, placing it into a caller-supplied buffer.

A terminating NUL character will be appended to the buffer if space is available.

The number of UChars in the output string, not including the terminating NUL, is returned.

If the supplied buffer is smaller than required to hold the output, the contents of the buffer are undefined. The full output string length (in UChars) is returned as always, and can be used to allocate a buffer of the correct size.

Parameters:

  | ucsm | The charset match object.
  | buf | A UChar buffer to be filled with the converted text data.
  | cap | The capacity of the buffer in UChars.
  | status | Any error conditions are reported back in this variable.

Returns:
  The number of UChars in the output string.

Stable:
  ICU 3.6

UBool ucsdet_isInputFilterEnabled | ( | const UCharsetDetector * | ucsd | ) |

Test whether input filtering is enabled for this charset detector.

Input filtering removes text that appears to be HTML or xml markup from the input before applying the code page detection heuristics.

Parameters:

  | ucsd | The charset detector to check.

Returns:
  TRUE if filtering is enabled.

Stable:
  ICU 3.6

UCharsetDetector* ucsdet_open | ( | UErrorCode * | status | ) |

Open a charset detector.

Parameters:

  | status | Any error conditions occurring during the open operation are reported back in this variable.

Returns:
  the newly opened charset detector.

Stable:
  ICU 3.6

void ucsdet_setDeclaredEncoding | ( | UCharsetDetector * | ucsd,
|  | const char * | encoding,
|  | int32_t | length,
|  | UErrorCode * | status |
| ) |  |  |

Set the declared encoding for charset detection.

The declared encoding of an input text is an encoding obtained by the user from an http header or xml declaration or similar source that can be provided as an additional hint to the charset detector.

How and whether the declared encoding will be used during the detection process is TBD.

Parameters:

  | ucsd | the charset detector to be used.
  | encoding | an encoding for the current data obtained from a header or declaration or other source outside of the byte data itself.
  | length | the length of the encoding name, or -1 if the name string is NUL terminated.
  | status | any error conditions are reported back in this variable.

Stable:
  ICU 3.6

void ucsdet_setText | ( | UCharsetDetector * | ucsd,
|  | const char * | textIn,
|  | int32_t | len,
|  | UErrorCode * | status |
| ) |  |  |

Set the input byte data whose charset is to detected.

Ownership of the input text byte array remains with the caller. The input string must not be altered or deleted until the charset detector is either closed or reset to refer to different input text.

Parameters:

  | ucsd | the charset detector to be used.
  | textIn | the input text of unknown encoding. .
  | len | the length of the input text, or -1 if the text is NUL terminated.
  | status | any error conditions are reported back in this variable.

Stable:
  ICU 3.6